// CircleIT © 2010
// Made by: Daniel van Willigen
// Last update 04-09-10

menu();

function archs(){
	win.close();
	var omf = 2.834645;
	var x = 0;
	var y  = 0;
	var l = 0;
	
	// set white
	var endColor = new CMYKColor();
	endColor.cyan = 0;
	endColor.magenta = 0;
	endColor.yellow = 0;
	endColor.black = 0;
	
	if (win.allGroups6.allGroups7.standard.value==true){
		var spreadxcorr = 0;
		var spreadycorr = 0;
	}else{
		if (win.allGroups6.allGroups7.randomcolor.value==true){
			var spreadxcorr = Math.random()*100;
			var spreadycorr = Math.random()*100;
			if (spreadxcorr > 20){var spreadxcorr = 20};
			if (spreadycorr > 20){var spreadycorr = 20};
		}else{
			var spreadxcorr = new Number(win.allGroups6.allGroups7.spreadxgroup.et.text);
			var spreadycorr = new Number(win.allGroups6.allGroups7.spreadygroup.et.text);
		}
	}

	// Set rows and columns
	if (win.allGroups6.allGroups5.randomcolor.value==true){
		var columndef = Math.random()*100;
		var rowsdef = Math.random()*100;
		if (columndef > 100){ var columndef = 100};
		if (rowsdef > 100){ var rowsdef = 100};
	}else{
		var columndef = win.allGroups6.allGroups5.columngroup.et.text;
		var rowsdef = win.allGroups6.allGroups5.rowsgroup.et.text;
	}

	// Set Correction (height)
	if (win.allGroups6.allGroups3.randomcolor.value==true){
		var correction = Math.random();
	}else{
		var correction = win.allGroups6.allGroups3.heightgroup.et.text/100;
	}
	
	var colorname = 0;
	
	// Set Size
	if (win.allGroups6.allGroups3.curvegroup.ddl.selection==0){
		if (win.allGroups6.allGroups3.randomcolor.value==true){
			var size = (Math.sin(l)*(Math.random()*100));
		}else{
			var size = (Math.sin(l)*win.allGroups6.allGroups3.sizegroup.et.text);
		}
	}
	if (win.allGroups6.allGroups3.curvegroup.ddl.selection==1){
		if (win.allGroups6.allGroups3.randomcolor.value==true){
			var size = (Math.cos(l)*(Math.random()*100));
		}else{
			var size = (Math.cos(l)*win.allGroups6.allGroups3.sizegroup.et.text);
		}
	}
	if (win.allGroups6.allGroups3.curvegroup.ddl.selection==2){
		if (win.allGroups6.allGroups3.randomcolor.value==true){
			var size = (Math.tan(l)*(Math.random()*100));
		}else{
			var size = (Math.tan(l)*win.allGroups6.allGroups3.sizegroup.et.text);
		}
	}
	if (win.allGroups6.allGroups3.curvegroup.ddl.selection==3){
		if (win.allGroups6.allGroups3.randomcolor.value==true){
			var size = ((Math.random(l))*(Math.random()*100));
		}else{
			var size = ((Math.random(l))*win.allGroups6.allGroups3.sizegroup.et.text);
		}
	}

	verschuivingx = 0;
	verschuivingy = 0;

	docPreset = new DocumentPreset;
	docPreset.width = 100*omf;
	docPreset.colorMode = DocumentColorSpace.CMYK
	docPreset.previewMode = DocumentPreviewMode.OverprintPreview;
	docPreset.rasterResolution = DocumentRasterResolution.HighResolution;
	docPreset.title = 'CircleIT Wave';
	docPreset.rulerUnits = RulerUnits.Millimeters;
	docPreset.height = (100*omf);
	docPreset.name = 'CircleIT Wave';
	var doc = app.documents.addDocument(DocumentColorSpace.CMYK,docPreset);
	app.activeDocument.layers[0].name = 'CircleIT Wave';

	if (win.allGroups6.allGroups.setallcolor.value==false && win.allGroups6.allGroups.randomcolor.value==false){
		// Define 4 colors:
		var newSpot = doc.spots.add();
		var topColor = new CMYKColor();
		topColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text;
		topColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text;
		topColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text;
		topColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text;
		newSpot.name = 'topColor';
		newSpot.colorType = ColorModel.PROCESS;
		newSpot.color = topColor;
		var newSpotColor = new SpotColor();
		newSpotColor.spot = newSpot;	
	
		var newSpot = doc.spots.add();
		var bottomColor = new CMYKColor();
		bottomColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text;
		bottomColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text;
		bottomColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text;
		bottomColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text;
		newSpot.name = 'bottomColor';
		newSpot.colorType = ColorModel.PROCESS;
		newSpot.color = bottomColor;
		var newSpotColor = new SpotColor();
		newSpotColor.spot = newSpot;	

		var newSpot = doc.spots.add();
		var leftColor = new CMYKColor();
		leftColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text;
		leftColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text;
		leftColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text;
		leftColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text;
		newSpot.name = 'leftColor';
		newSpot.colorType = ColorModel.PROCESS;
		newSpot.color = leftColor;
		var newSpotColor = new SpotColor();
		newSpotColor.spot = newSpot;		
	}

		// Set Color
		var newSpot = doc.spots.add();
		var newColor = new CMYKColor();
		newSpot.name = 'Wave' + colorname;
		newSpot.colorType = ColorModel.PROCESS;
		newSpot.color = newColor;
		var newSpotColor = new SpotColor();
		newSpotColor.spot = newSpot;

	for (var m = 0; m < columndef; m++ ) {	

		if (win.allGroups6.allGroups.randomcolor.value==true){
			newColor.cyan = Math.random()*100;
			newColor.magenta = Math.random()*100;
			newColor.yellow = Math.random()*100;
			newColor.black = Math.random()*100;
		} else {
			if (win.allGroups6.allGroups.setallcolor.value==true && win.allGroups6.allGroups.colorgroup.ddl.selection == 0){
				newColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text;
				newColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text;
				newColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text;
				newColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text;
			}
			if (win.allGroups6.allGroups.setallcolor.value==true && win.allGroups6.allGroups.colorgroup.ddl.selection == 1){
				newColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text;
				newColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text;
				newColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text;
				newColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text;
			}
			if (win.allGroups6.allGroups.setallcolor.value==true && win.allGroups6.allGroups.colorgroup.ddl.selection == 2){
				newColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text;
				newColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text;
				newColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text;
				newColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text;
			}	
		}

		// Set Percentage
		if (win.allGroups6.allGroups2.randomcolor.value==true){
			bottomtint = Math.random()*100;
			toptint = Math.random()*100;
			lefttint = Math.random()*100;
			righttint = Math.random()*100;
		} else {
			bottomtint = win.allGroups6.allGroups2.percentagebottomgroup.et.text;
			toptint = win.allGroups6.allGroups2.percentagetopgroup.et.text;
			lefttint = win.allGroups6.allGroups2.percentageleftgroup.et.text;
		}

		for (var k = 0; k < rowsdef; k++ ) {
			if(win.allGroups6.allGroups4.radio1.value==true){
				if (size < 0){ var size = 0 };
			}
			if(win.allGroups6.allGroups4.radio2.value==true){
				if (size > 0){ var size = 0 };
			}
			var artworkgroup = doc.groupItems.add();	

			// Set gradient
			var newGradient = doc.gradients.add();
			newGradient.name = 'Wave Gradient' + colorname;
			newGradient.type = GradientType.LINEAR;
			newGradient.gradientStops[0].rampPoint = 0;
			if (win.allGroups6.allGroups.setallcolor.value==false && win.allGroups6.allGroups.randomcolor.value==false){
				newGradient.gradientStops[0].color = doc.swatches['leftColor'].color;;
			}else{
				newGradient.gradientStops[0].color = doc.swatches['Wave' + colorname].color;
			}		
			newGradient.gradientStops[1].rampPoint = 100;
			newGradient.gradientStops[1].color = endColor;
			var colorOfGradient = new GradientColor();
			colorOfGradient.gradient = newGradient;

			//circle middle
			var line = doc.pathItems.add();
			line.stroked = true;
			line.setEntirePath( Array( Array(((x+0+verschuivingx)*omf),((y+11.624+size-verschuivingy)*omf)), Array(((x+1.032+verschuivingx)*omf),((y+9.117+size-verschuivingy)*omf)), Array(((x+3.53+verschuivingx)*omf),((y+8.08+size-verschuivingy)*omf)), Array(((x+6.027+verschuivingx)*omf),((y+9.118+size-verschuivingy)*omf)), Array(((x+7.06+verschuivingx)*omf),((y+11.624+size-verschuivingy)*omf)), Array(((x+7.06+verschuivingx)*omf),((y+3.544-verschuivingy)*omf)), Array(((x+6.027+verschuivingx)*omf),((y+6.032-verschuivingy)*omf)), Array(((x+3.53+verschuivingx)*omf),((y+7.07-verschuivingy)*omf)), Array(((x+1.032+verschuivingx)*omf),((y+6.033-verschuivingy)*omf)), Array(((x+0+verschuivingx)*omf),((y+3.544-verschuivingy)*omf)), Array(((x+0+verschuivingx)*omf),((y+11.624+size-verschuivingy)*omf))));
			line.pathPoints[1].leftDirection = Array(((x+-0.002+verschuivingx)*omf),((y+10.152+size-verschuivingy)*omf));
			line.pathPoints[1].rightDirection = Array(((x+2.067+verschuivingx)*omf),((y+8.083+size-verschuivingy)*omf));
			line.pathPoints[3].leftDirection = Array(((x+4.992+verschuivingx)*omf),((y+8.083+size-verschuivingy)*omf));
			line.pathPoints[3].rightDirection = Array(((x+7.062+verschuivingx)*omf),((y+10.153+size-verschuivingy)*omf));
			line.pathPoints[6].leftDirection = Array(((x+7.062+verschuivingx)*omf),((y+4.997-verschuivingy)*omf));
			line.pathPoints[6].rightDirection = Array(((x+4.992+verschuivingx)*omf),((y+7.067-verschuivingy)*omf));
			line.pathPoints[8].leftDirection = Array(((x+2.067+verschuivingx)*omf),((y+7.067-verschuivingy)*omf));
			line.pathPoints[8].rightDirection = Array(((x+-0.002+verschuivingx)*omf),((y+4.998-verschuivingy)*omf));
			line.pointType = PointType.CORNER;
			line.filled= true;
			line.stroked = false;
			line.fillOverprint = false;
			if (win.allGroups6.allGroups.setallcolor.value==false && win.allGroups6.allGroups.randomcolor.value==false){
				line.fillColor = colorOfGradient;
			}else{
				line.fillColor = colorOfGradient;
			}
			line.fillColor.tint = lefttint;

			//circle bottom
			var line = doc.pathItems.add();
			line.stroked = true;
			line.setEntirePath( Array( Array(((x+0+verschuivingx)*omf),((y+3.544-verschuivingy)*omf)), Array(((x+1.032+verschuivingx)*omf),((y+6.033-verschuivingy)*omf)), Array(((x+3.53+verschuivingx)*omf),((y+7.07-verschuivingy)*omf)), Array(((x+6.027+verschuivingx)*omf),((y+6.032-verschuivingy)*omf)), Array(((x+7.06+verschuivingx)*omf),((y+3.544-verschuivingy)*omf)), Array(((x+6.027+verschuivingx)*omf),((y+1.038-verschuivingy)*omf)), Array(((x+3.53+verschuivingx)*omf),((y+0-verschuivingy)*omf)), Array(((x+1.032+verschuivingx)*omf),((y+1.037-verschuivingy)*omf)), Array(((x+0+verschuivingx)*omf),((y+3.544-verschuivingy)*omf))));
			line.pathPoints[1].leftDirection = Array(((x+-0.002+verschuivingx)*omf),((y+4.998-verschuivingy)*omf));
			line.pathPoints[1].rightDirection = Array(((x+2.067+verschuivingx)*omf),((y+7.067-verschuivingy)*omf));
			line.pathPoints[3].leftDirection = Array(((x+4.992+verschuivingx)*omf),((y+7.067-verschuivingy)*omf));
			line.pathPoints[3].rightDirection = Array(((x+7.062+verschuivingx)*omf),((y+4.997-verschuivingy)*omf));
			line.pathPoints[5].leftDirection = Array(((x+7.062+verschuivingx)*omf),((y+2.073-verschuivingy)*omf));
			line.pathPoints[5].rightDirection = Array(((x+4.992+verschuivingx)*omf),((y+0.003-verschuivingy)*omf));
			line.pathPoints[7].leftDirection = Array(((x+2.067+verschuivingx)*omf),((y+0.003-verschuivingy)*omf));
			line.pathPoints[7].rightDirection = Array(((x+-0.002+verschuivingx)*omf),((y+2.072-verschuivingy)*omf));
			line.pointType = PointType.CORNER;
			line.filled= true;
			line.stroked = false;
			line.fillOverprint = false;
			if (win.allGroups6.allGroups.setallcolor.value==false && win.allGroups6.allGroups.randomcolor.value==false){
				if (size < 0){line.fillColor = doc.swatches['bottomColor'].color};
				if (size == 0){line.fillColor = colorOfGradient};
				if (size > 0){line.fillColor = colorOfGradient};
			}else{
				if (size < 0){line.fillColor = doc.swatches['Wave' + colorname].color};
				if (size == 0){line.fillColor = colorOfGradient};
				if (size > 0){line.fillColor = colorOfGradient};
			}
			line.fillColor.tint = bottomtint;

			//circle top
			var line = doc.pathItems.add();
			line.stroked = true;
			line.setEntirePath( Array( Array(((x+0+verschuivingx)*omf),((y+11.624+size-verschuivingy)*omf)), Array(((x+1.032+verschuivingx)*omf),((y+14.113+size-verschuivingy)*omf)), Array(((x+3.53+verschuivingx)*omf),((y+15.15+size-verschuivingy)*omf)), Array(((x+6.027+verschuivingx)*omf),((y+14.112+size-verschuivingy)*omf)), Array(((x+7.06+verschuivingx)*omf),((y+11.624+size-verschuivingy)*omf)), Array(((x+6.027+verschuivingx)*omf),((y+9.118+size-verschuivingy)*omf)), Array(((x+3.53+verschuivingx)*omf),((y+8.08+size-verschuivingy)*omf)), Array(((x+1.032+verschuivingx)*omf),((y+9.117+size-verschuivingy)*omf)),Array(((x+0+verschuivingx)*omf),((y+11.624+size-verschuivingy)*omf))));
			line.pathPoints[1].leftDirection = Array(((x+-0.002+verschuivingx)*omf),((y+13.078+size-verschuivingy)*omf));
			line.pathPoints[1].rightDirection = Array(((x+2.067+verschuivingx)*omf),((y+15.147+size-verschuivingy)*omf));
			line.pathPoints[3].leftDirection = Array(((x+4.992+verschuivingx)*omf),((y+15.147+size-verschuivingy)*omf));
			line.pathPoints[3].rightDirection = Array(((x+7.062+verschuivingx)*omf),((y+13.077+size-verschuivingy)*omf));
			line.pathPoints[5].leftDirection = Array(((x+7.062+verschuivingx)*omf),((y+10.153+size-verschuivingy)*omf));
			line.pathPoints[5].rightDirection = Array(((x+4.992+verschuivingx)*omf),((y+8.083+size-verschuivingy)*omf));
			line.pathPoints[7].leftDirection = Array(((x+2.067+verschuivingx)*omf),((y+8.083+size-verschuivingy)*omf));
			line.pathPoints[7].rightDirection = Array(((x+-0.002+verschuivingx)*omf),((y+10.152+size-verschuivingy)*omf));
			line.pointType = PointType.CORNER;
			line.filled= true;
			line.stroked = false;
			line.fillOverprint = false;
			if (win.allGroups6.allGroups.setallcolor.value==false && win.allGroups6.allGroups.randomcolor.value==false){
				if (size > 0){line.fillColor = doc.swatches['topColor'].color};
				if (size == 0){line.fillColor = doc.swatches['topColor'].color};
				if (size < 0){line.fillColor = colorOfGradient};
			}else{
				if (size > 0){line.fillColor = doc.swatches['Wave' + colorname].color};
				if (size == 0){line.fillColor = doc.swatches['Wave' + colorname].color};
				if (size < 0){line.fillColor = colorOfGradient};
			}
			line.fillColor.tint = toptint;
	
			l = l + correction;

			verschuivingx = verschuivingx + 3.535+spreadxcorr;
			verschuivingy = verschuivingy + 3.536+spreadycorr;

			if (win.allGroups6.allGroups3.curvegroup.ddl.selection==0){
				var size = (Math.sin(l)*win.allGroups6.allGroups3.sizegroup.et.text);
			}
			if (win.allGroups6.allGroups3.curvegroup.ddl.selection==1){
				var size = (Math.cos(l)*win.allGroups6.allGroups3.sizegroup.et.text);
			}
			if (win.allGroups6.allGroups3.curvegroup.ddl.selection==2){
				var size = (Math.tan(l)*win.allGroups6.allGroups3.sizegroup.et.text);
			}
		
			colorname = colorname + 1;
			
			if (win.allGroups6.allGroups.setallcolor.value==true || win.allGroups6.allGroups.randomcolor.value==true){
				var newSpot = doc.spots.add();
				var newColor = new CMYKColor();
				if (win.allGroups6.allGroups.randomcolor.value==true){
					newColor.cyan = Math.random()*100;
					newColor.magenta = Math.random()*100;
					newColor.yellow = Math.random()*100;
					newColor.black = Math.random()*100;
				} else {
					if (win.allGroups6.allGroups.setallcolor.value==true && win.allGroups6.allGroups.colorgroup.ddl.selection == 0){
						newColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text;
						newColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text;
						newColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text;
						newColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text;
					}
					if (win.allGroups6.allGroups.setallcolor.value==true && win.allGroups6.allGroups.colorgroup.ddl.selection == 1){
						newColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text;
						newColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text;
						newColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text;
						newColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text;
					}
					if (win.allGroups6.allGroups.setallcolor.value==true && win.allGroups6.allGroups.colorgroup.ddl.selection == 2){
						newColor.cyan = win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text;
						newColor.magenta = win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text;
						newColor.yellow = win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text;
						newColor.black = win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text;
					}	
				}
				newSpot.name = 'Wave' + colorname;
				newSpot.colorType = ColorModel.PROCESS;
				newSpot.color = newColor;
				var newSpotColor = new SpotColor();
				newSpotColor.spot = newSpot;
			};
		};
		verschuivingx = 0;
		verschuivingy = 0;
		x = x - 3.535 - spreadxcorr;
		y  = y - 3.536 - spreadycorr;
		l = l + correction;
	};

	var illustratorversion = app.version;
	var illustratorversionarray = illustratorversion.split('.');
	if(illustratorversionarray[0]>13){
		app.activeDocument.artboards[0].artboardRect = app.activeDocument.visibleBounds;
	}
	zet_nulpunt();
	zoomcenterpage()
};

function menu(){
	res =
	"dialog { \
		text:'CircleIT:', \
		properties:{ closeOnKey:'OSCmnd+W', resizeable:false}, \
			ddl: DropDownList { alignment:'left', preferredSize: [260, 20] }, \
			allGroups6: Panel { orientation:'stack', alignChildren:'top', preferredSize: [200, 20],\
			text: 'Color', \
			allGroups: Group { alignment:'left', orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
			colorgroup: Group { alignment:'left',\
				st: StaticText { text:'Color    :' }, \
				ddl: DropDownList { alignment:'left', preferredSize: [165, 20] }, \
				} \
			colorflip:Group { orientation:'stack', alignChildren:'top', preferredSize: [200, 20],\
				setcolorgroup1: Group { alignment:'left', orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
					cyangroup: Group { alignment:'left',\
						st: StaticText { text:'Cyan     :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:100 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					magentagroup: Group { alignment:'left',\
						st: StaticText { text:'Magenta:' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					yellowgroup: Group { alignment:'left',\
						st: StaticText { text:'Yellow   :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					blackgroup: Group { alignment:'left',\
						st: StaticText { text:'Black     :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
				} \
				setcolorgroup2: Group { alignment:'left', orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
					cyangroup: Group { alignment:'left',\
						st: StaticText { text:'Cyan     :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					magentagroup: Group { alignment:'left',\
						st: StaticText { text:'Magenta:' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:100 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					yellowgroup: Group { alignment:'left',\
						st: StaticText { text:'Yellow   :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					blackgroup: Group { alignment:'left',\
						st: StaticText { text:'Black     :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
				} \
				setcolorgroup3: Group { alignment:'left', orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
					cyangroup: Group { alignment:'left',\
						st: StaticText { text:'Cyan     :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					magentagroup: Group { alignment:'left',\
						st: StaticText { text:'Magenta:' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					yellowgroup: Group { alignment:'left',\
						st: StaticText { text:'Yellow   :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:100 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
					blackgroup: Group { alignment:'left',\
						st: StaticText { text:'Black     :' }, \
						sl: Slider { minvalue:0, maxvalue:100, value:0 }, \
						et: EditText { characters:4, justify:'right' } \
						} \
				} \
			} \
			setallcolor: Checkbox { \
			alignment:'left', text:'Set all colors to current value', value:false \
				} \
			randomcolor: Checkbox { \
			alignment:'left', text:'Set color to random', value:true \
			}, \
			}, \
			allGroups2: Group { orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
			percentagetopgroup: Group { alignment:'left',\
				st: StaticText { text:'Top      :' }, \
				sl: Slider { minvalue:0, maxvalue:100, value:50 }, \
				et: EditText { characters:4, justify:'right' } \
				} \
			percentageleftgroup: Group { alignment:'left',\
				st: StaticText { text:'Middle  :' }, \
				sl: Slider { minvalue:0, maxvalue:100, value:60 }, \
					et: EditText { characters:4, justify:'right' } \
				} \
			percentagebottomgroup: Group { alignment:'left',\
				st: StaticText { text:'Bottom :' }, \
				sl: Slider { minvalue:0, maxvalue:100, value:50 }, \
					et: EditText { characters:4, justify:'right' } \
				} \
			randomcolor: Checkbox { \
			alignment:'left', text:'Set percentage to random', value:false \
			}, \
			}, \
			allGroups3: Group { orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
			curvegroup: Group { alignment:'left',\
				st: StaticText { text:'Curve  :' }, \
				ddl: DropDownList { alignment:'left', preferredSize: [165, 20] }, \
				} \
			sizegroup: Group { alignment:'left',\
				st: StaticText { text:'Size     :' }, \
				sl: Slider { minvalue:1, maxvalue:100, value:100 }, \
					et: EditText { characters:4, justify:'right' } \
				} \
			heightgroup: Group { alignment:'left',\
				st: StaticText { text:'Height :' }, \
				sl: Slider { minvalue:1, maxvalue:100, value:10 }, \
				et: EditText { characters:4, justify:'right' } \
				} \
			randomcolor: Checkbox { \
			alignment:'left', text:'Set size and height to random', value:false \
			}, \
			}, \
			allGroups4: Group { orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
			radio1: RadioButton { alignment:'left', text:'Positive', value:true }, \
			radio2: RadioButton { alignment:'left', text:'Negative' }, \
			radio3: RadioButton { alignment:'left', text:'Positive and Negative' } \
			}, \
			allGroups5: Group { orientation:'column', preferredSize: [200, 20] \
			rowsgroup: Group { alignment:'left',\
				st: StaticText { text:'Rows     :' }, \
				sl: Slider { minvalue:1, maxvalue:100, value:32 }, \
					et: EditText { characters:4, justify:'right' } \
				} \
			columngroup: Group { alignment:'left',\
				st: StaticText { text:'Columns:' }, \
				sl: Slider { minvalue:1, maxvalue:100, value:32 }, \
				et: EditText { characters:4, justify:'right' } \
				} \
			randomcolor: Checkbox { \
			alignment:'left', text:'Set rows and columns to random', value:false \
			}, \
			}, \
			allGroups7: Group { orientation:'column', preferredSize: [200, 20], alignChildren:'top', \
			spreadxgroup: Group { alignment:'left',\
				st: StaticText { text:'Spread x:' }, \
				sl: Slider { minvalue:0, maxvalue:20, value:0 }, \
				et: EditText { characters:4, justify:'right' } \
				} \
			spreadygroup: Group { alignment:'left',\
				st: StaticText { text:'Spread y:' }, \
				sl: Slider { minvalue:0, maxvalue:20, value:0 }, \
				et: EditText { characters:4, justify:'right' } \
				} \
			randomcolor: Checkbox { \
			alignment:'left', text:'Set spread x an y to random', value:false \
				} \
			standard: Checkbox { \
			alignment:'left', text:'Standard', value:true \
			}, \
			}, \
			} \
			buttons: Group { orientation: 'row', alignment: 'center', \
			cancelBtn: Button { text:'Cancel', properties:{name:'cancel'} }, \
			applyBtn: Button { text:'Apply', properties:{name:'apply'} }, \
		} \
	}";

	win = new Window (res);
	win.frameLocation = [100, 100];

	// Global menu startup settings
	win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.sl.value);
	
	win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.sl.value);
	win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.sl.value);
	win.allGroups6.allGroups2.percentagetopgroup.et.text = Math.round(win.allGroups6.allGroups2.percentagetopgroup.sl.value);
	win.allGroups6.allGroups2.percentageleftgroup.et.text = Math.round(win.allGroups6.allGroups2.percentageleftgroup.sl.value);
	win.allGroups6.allGroups2.percentagebottomgroup.et.text = Math.round(win.allGroups6.allGroups2.percentagebottomgroup.sl.value);
	win.allGroups6.allGroups3.sizegroup.et.text = Math.round(win.allGroups6.allGroups3.sizegroup.sl.value);
	win.allGroups6.allGroups3.heightgroup.et.text = Math.round(win.allGroups6.allGroups3.heightgroup.sl.value);
	win.allGroups6.allGroups5.rowsgroup.et.text = Math.round(win.allGroups6.allGroups5.rowsgroup.sl.value);
	win.allGroups6.allGroups5.columngroup.et.text = Math.round(win.allGroups6.allGroups5.columngroup.sl.value);
	win.allGroups6.allGroups2.percentagetopgroup.enabled = true;
	win.allGroups6.allGroups2.percentageleftgroup.enabled = true;
	win.allGroups6.allGroups2.percentagebottomgroup.enabled = true;
	win.allGroups6.allGroups3.sizegroup.enabled = true;
	win.allGroups6.allGroups3.heightgroup.enabled = true;
	win.allGroups6.allGroups5.rowsgroup.enabled = true;
	win.allGroups6.allGroups5.columngroup.enabled = true;
	win.allGroups6.allGroups.colorgroup.enabled = false;
	win.allGroups6.allGroups.setallcolor.enabled = false;
	win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.enabled = false;
	win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.enabled = false;
	win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.enabled = false;
	win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.enabled = false;
	win.allGroups6.allGroups7.randomcolor.enabled = false;
	win.allGroups6.allGroups7.spreadxgroup.enabled = false;
	win.allGroups6.allGroups7.spreadygroup.enabled = false;
	win.allGroups6.allGroups7.spreadxgroup.et.text = Math.round(win.allGroups6.allGroups7.spreadxgroup.sl.value);
	win.allGroups6.allGroups7.spreadygroup.et.text = Math.round(win.allGroups6.allGroups7.spreadygroup.sl.value);

	win.ddl.onChange = function () {
		if (this.selection != null) {
			for (var g = 0; g < this.items.length; g++)
				this.items[g].group.visible = false; //hide all other groups
				this.selection.group.visible = true;//show this group
			}
		if (win.ddl.selection == 0){win.allGroups6.text = 'Color Top';}
		if (win.ddl.selection == 1){win.allGroups6.text = 'Percentage';}
		if (win.ddl.selection == 3){win.allGroups6.text = 'Pos or Negative';}
		if (win.ddl.selection == 2){win.allGroups6.text = 'Size';}
		if (win.ddl.selection == 4){win.allGroups6.text = 'Rows and Columns';}
		if (win.ddl.selection == 5){win.allGroups6.text = 'Spread';}
		}

	var item = win.ddl.add ('item', 'Color');
	item.group = win.allGroups6.allGroups;
	item = win.ddl.add ('item', 'Percentage bloks');
	item.group = win.allGroups6.allGroups2;
	item = win.ddl.add ('item', 'Size');
	item.group = win.allGroups6.allGroups3;
	item = win.ddl.add ('item', 'Pos or Negative');
	item.group = win.allGroups6.allGroups4;
	item = win.ddl.add ('item', 'Rows and Columns');
	item.group = win.allGroups6.allGroups5;
	item = win.ddl.add ('item', 'Spread');
	item.group = win.allGroups6.allGroups7;
	win.ddl.selection = win.ddl.items[0];

	// Color dropdownlist
	win.allGroups6.allGroups.colorgroup.ddl.onChange = function () {
		if (this.selection != null) {
			for (var g = 0; g < this.items.length; g++)
				this.items[g].group.visible = false; //hide all other groups
				this.selection.group.visible = true;//show this group
			}
		if (win.allGroups6.allGroups.colorgroup.ddl.selection == 0){win.allGroups6.text = 'Color Top';}
		if (win.allGroups6.allGroups.colorgroup.ddl.selection == 1){win.allGroups6.text = 'Color Bottom';}
		if (win.allGroups6.allGroups.colorgroup.ddl.selection == 2){win.allGroups6.text = 'Color Middle';}
		}	

	var item = win.allGroups6.allGroups.colorgroup.ddl.add ('item', 'Color Top');
	item.group = win.allGroups6.allGroups.colorflip.setcolorgroup1;
	item  = win.allGroups6.allGroups.colorgroup.ddl.add ('item', 'Color Bottom');
	item.group = win.allGroups6.allGroups.colorflip.setcolorgroup2;
	item  = win.allGroups6.allGroups.colorgroup.ddl.add ('item', 'Color Middle');
	item.group = win.allGroups6.allGroups.colorflip.setcolorgroup3;
	win.allGroups6.allGroups.colorgroup.ddl.selection = win.allGroups6.allGroups.colorgroup.ddl.items[0];

	var dropdownlistsize = win.allGroups6.allGroups3.curvegroup.ddl.add ('item', 'Sin');
	dropdownlistsize = win.allGroups6.allGroups3.curvegroup.ddl.add ('item', 'Cos');
	dropdownlistsize = win.allGroups6.allGroups3.curvegroup.ddl.add ('item', 'Tan');
	dropdownlistsize = win.allGroups6.allGroups3.curvegroup.ddl.add ('item', 'Random');
	win.allGroups6.allGroups3.curvegroup.ddl.selection = win.allGroups6.allGroups3.curvegroup.ddl.items[0];

	// random color 
	win.allGroups6.allGroups.randomcolor.onClick = function () { 
		if (win.allGroups6.allGroups.randomcolor.value==true){
			if (win.allGroups6.allGroups.setallcolor.value==true){
				win.allGroups6.allGroups.colorgroup.enabled = false;
			};
			if (win.allGroups6.allGroups.setallcolor.value==false){
				win.allGroups6.allGroups.colorgroup.enabled = false;
			};
			win.allGroups6.allGroups.setallcolor.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.enabled = false;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.enabled = false;
		};
		if (win.allGroups6.allGroups.randomcolor.value==false){
			if (win.allGroups6.allGroups.setallcolor.value==true){
				win.allGroups6.allGroups.colorgroup.enabled = false;
			};
			if (win.allGroups6.allGroups.setallcolor.value==false){
				win.allGroups6.allGroups.colorgroup.enabled = true;
			};
			win.allGroups6.allGroups.setallcolor.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.enabled = true;
			win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.enabled = true;
		};
	}

	// random color
	win.allGroups6.allGroups.setallcolor.onClick = function () { 
		if (win.allGroups6.allGroups.setallcolor.value==true){
			win.allGroups6.allGroups.colorgroup.enabled = false;
		};
		if (win.allGroups6.allGroups.setallcolor.value==false){
			win.allGroups6.allGroups.colorgroup.enabled = true;
		};
	}

	// random percentage
	win.allGroups6.allGroups2.randomcolor.onClick = function () { 
		if (win.allGroups6.allGroups2.randomcolor.value==true){
			win.allGroups6.allGroups2.percentagetopgroup.enabled = false;
			win.allGroups6.allGroups2.percentageleftgroup.enabled = false;
			win.allGroups6.allGroups2.percentagebottomgroup.enabled = false;
		};
		if (win.allGroups6.allGroups2.randomcolor.value==false){
			win.allGroups6.allGroups2.percentagetopgroup.enabled = true;
			win.allGroups6.allGroups2.percentageleftgroup.enabled = true;
			win.allGroups6.allGroups2.percentagebottomgroup.enabled = true;
		};
	}

	// random percentage
	win.allGroups6.allGroups3.randomcolor.onClick = function () { 
		if (win.allGroups6.allGroups3.randomcolor.value==true){
			win.allGroups6.allGroups3.sizegroup.enabled = false;
			win.allGroups6.allGroups3.heightgroup.enabled = false;
		};
		if (win.allGroups6.allGroups3.randomcolor.value==false){
			win.allGroups6.allGroups3.sizegroup.enabled = true;
			win.allGroups6.allGroups3.heightgroup.enabled = true;
		};
	}

	// random rows and columns
	win.allGroups6.allGroups5.randomcolor.onClick = function () { 
		if (win.allGroups6.allGroups5.randomcolor.value==true){
			win.allGroups6.allGroups5.rowsgroup.enabled = false;
			win.allGroups6.allGroups5.columngroup.enabled = false;
		};
		if (win.allGroups6.allGroups5.randomcolor.value==false){
			win.allGroups6.allGroups5.rowsgroup.enabled = true;
			win.allGroups6.allGroups5.columngroup.enabled = true;
		};
	}

	// spread standard
	win.allGroups6.allGroups7.standard.onClick = function () { 
		if (win.allGroups6.allGroups7.standard.value==true){
			win.allGroups6.allGroups7.spreadxgroup.enabled = false;
			win.allGroups6.allGroups7.spreadygroup.enabled = false;
			win.allGroups6.allGroups7.randomcolor.enabled = false;
		};
		if (win.allGroups6.allGroups7.standard.value==false){
			win.allGroups6.allGroups7.spreadxgroup.enabled = true;
			win.allGroups6.allGroups7.spreadygroup.enabled = true;
			win.allGroups6.allGroups7.randomcolor.enabled = true;
		};
	}

	// spread standard random
	win.allGroups6.allGroups7.randomcolor.onClick = function () { 
		if (win.allGroups6.allGroups7.randomcolor.value==true){
			win.allGroups6.allGroups7.spreadxgroup.enabled = false;
			win.allGroups6.allGroups7.spreadygroup.enabled = false;
		};
		if (win.allGroups6.allGroups7.randomcolor.value==false){
			win.allGroups6.allGroups7.spreadxgroup.enabled = true;
			win.allGroups6.allGroups7.spreadygroup.enabled = true;
		};
	}

	// sliders spread
	win.allGroups6.allGroups7.spreadxgroup.sl.onChange = function () { 
		win.allGroups6.allGroups7.spreadxgroup.et.text = Math.round(win.allGroups6.allGroups7.spreadxgroup.sl.value);
	}
	win.allGroups6.allGroups7.spreadygroup.sl.onChange = function () { 
		win.allGroups6.allGroups7.spreadygroup.et.text = Math.round(win.allGroups6.allGroups7.spreadygroup.sl.value);
	}
	win.allGroups6.allGroups7.spreadxgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups7.spreadxgroup.et.text > 20){win.allGroups6.allGroups7.spreadxgroup.et.text = 20}
		if (win.allGroups6.allGroups7.spreadxgroup.et.text < 0){win.allGroups6.allGroups7.spreadxgroup.et.text = 0}
		win.allGroups6.allGroups7.spreadxgroup.sl.value= win.allGroups6.allGroups7.spreadxgroup.et.text
	}
	win.allGroups6.allGroups7.spreadygroup.et.onChange = function () { 
		if (win.allGroups6.allGroups7.spreadygroup.et.text > 20){win.allGroups6.allGroups7.spreadygroup.et.text = 20}
		if (win.allGroups6.allGroups7.spreadygroup.et.text < 0){win.allGroups6.allGroups7.spreadygroup.et.text = 0}
		win.allGroups6.allGroups7.spreadygroup.sl.value= win.allGroups6.allGroups7.spreadygroup.et.text
	}

	// sliders color 1
	win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup1.cyangroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup1.magentagroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup1.yellowgroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup1.blackgroup.et.text
	}

	// sliders color 2
	win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup2.cyangroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup2.magentagroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup2.yellowgroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup2.blackgroup.et.text
	}

	// sliders color 3
	win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.sl.onChange = function () { 
		win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text = Math.round(win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.sl.value);
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup3.cyangroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup3.magentagroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup3.yellowgroup.et.text
	}
	win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text > 100){win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text = 100}
		if (win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text < 0){win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text = 0}
		win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.sl.value= win.allGroups6.allGroups.colorflip.setcolorgroup3.blackgroup.et.text
	}

	// sliders percentage blocks
	win.allGroups6.allGroups2.percentagetopgroup.sl.onChange = function () { 
		win.allGroups6.allGroups2.percentagetopgroup.et.text = Math.round(win.allGroups6.allGroups2.percentagetopgroup.sl.value);
	}
	win.allGroups6.allGroups2.percentageleftgroup.sl.onChange = function () { 
		win.allGroups6.allGroups2.percentageleftgroup.et.text = Math.round(win.allGroups6.allGroups2.percentageleftgroup.sl.value);
	}
	win.allGroups6.allGroups2.percentagebottomgroup.sl.onChange = function () { 
		win.allGroups6.allGroups2.percentagebottomgroup.et.text = Math.round(win.allGroups6.allGroups2.percentagebottomgroup.sl.value);
	}
	win.allGroups6.allGroups2.percentagetopgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups2.percentagetopgroup.et.text > 100){win.allGroups6.allGroups2.percentagetopgroup.et.text = 100}
		if (win.allGroups6.allGroups2.percentagetopgroup.et.text < 0){win.allGroups6.allGroups2.percentagetopgroup.et.text = 0}
		win.allGroups6.allGroups2.percentagetopgroup.sl.value= win.allGroups6.allGroups2.percentagetopgroup.et.text
	}
	win.allGroups6.allGroups2.percentageleftgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups2.percentageleftgroup.et.text > 100){win.allGroups6.allGroups2.percentageleftgroup.et.text = 100}
		if (win.allGroups6.allGroups2.percentageleftgroup.et.text < 0){win.allGroups6.allGroups2.percentageleftgroup.et.text = 0}
		win.allGroups6.allGroups2.percentageleftgroup.sl.value= win.allGroups6.allGroups2.percentageleftgroup.et.text
	}
	win.allGroups6.allGroups2.percentagebottomgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups2.percentagebottomgroup.et.text > 100){win.allGroups6.allGroups2.percentagebottomgroup.et.text = 100}
		if (win.allGroups6.allGroups2.percentagebottomgroup.et.text < 0){win.allGroups6.allGroups2.percentagebottomgroup.et.text = 0}
		win.allGroups6.allGroups2.percentagebottomgroup.sl.value= win.allGroups6.allGroups2.percentagebottomgroup.et.text
	}

	// sliders size
	win.allGroups6.allGroups3.sizegroup.sl.onChange = function () { 
		win.allGroups6.allGroups3.sizegroup.et.text = Math.round(win.allGroups6.allGroups3.sizegroup.sl.value);
	}
	win.allGroups6.allGroups3.heightgroup.sl.onChange = function () { 
		win.allGroups6.allGroups3.heightgroup.et.text = Math.round(win.allGroups6.allGroups3.heightgroup.sl.value);
	}
	win.allGroups6.allGroups3.sizegroup.et.onChange = function () { 
		if (win.allGroups6.allGroups3.sizegroup.et.text > 100){win.allGroups6.allGroups3.sizegroup.et.text = 100}
		if (win.allGroups6.allGroups3.sizegroup.et.text < 1){win.allGroups6.allGroups3.sizegroup.et.text = 1}
		win.allGroups6.allGroups3.sizegroup.sl.value= win.allGroups6.allGroups3.sizegroup.et.text
	}
	win.allGroups6.allGroups3.heightgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups3.heightgroup.et.text > 100){win.allGroups6.allGroups3.heightgroup.et.text = 100}
		if (win.allGroups6.allGroups3.heightgroup.et.text < 1){win.allGroups6.allGroups3.heightgroup.et.text = 1}
		win.allGroups6.allGroups3.heightgroup.sl.value= win.allGroups6.allGroups3.heightgroup.et.text
	}

	// sliders rows and columns
	win.allGroups6.allGroups5.rowsgroup.sl.onChange = function () { 
		win.allGroups6.allGroups5.rowsgroup.et.text = Math.round(win.allGroups6.allGroups5.rowsgroup.sl.value);
	}
	win.allGroups6.allGroups5.columngroup.sl.onChange = function () { 
		win.allGroups6.allGroups5.columngroup.et.text = Math.round(win.allGroups6.allGroups5.columngroup.sl.value);
	}
	win.allGroups6.allGroups5.rowsgroup.et.onChange = function () { 
		if (win.allGroups6.allGroups5.rowsgroup.et.text > 100){win.allGroups6.allGroups5.rowsgroup.et.text = 100}
		if (win.allGroups6.allGroups5.rowsgroup.et.text < 1){win.allGroups6.allGroups5.rowsgroup.et.text = 1}
		win.allGroups6.allGroups5.rowsgroup.sl.value= win.allGroups6.allGroups5.rowsgroup.et.text
	}
	win.allGroups6.allGroups5.columngroup.et.onChange = function () { 
		if (win.allGroups6.allGroups5.columngroup.et.text > 100){win.allGroups6.allGroups5.columngroup.et.text = 100}
		if (win.allGroups6.allGroups5.columngroup.et.text < 1){win.allGroups6.allGroups5.columngroup.et.text = 1}
		win.allGroups6.allGroups5.columngroup.sl.value= win.allGroups6.allGroups5.columngroup.et.text
	}

	// apply button
	win.buttons.applyBtn.onClick = function () {	
		archs();
	}

	win.center();
	win.show();
};

function zoomcenterpage(){
		var myView=app.activeDocument.views[0];
		myView.centerPoint = [(app.activeDocument.width/2),(app.activeDocument.height/2)];
		myView.zoom = 1
		myView.screenMode.FULLSCREEN;
}
	
function zet_nulpunt(){
	// zet nulpunt linksonder
	app.activeDocument.pageOrigin = Array(0,0);
	app.activeDocument.rulerOrigin = Array(0,0);
}
